
/****************** SECTION 1 ******************/
#ifndef  __cplusplus
#define TIMEOUT 6000 /* milliseconds */
#define RETRIES 3
#define MAX_OID_NAME_LENGTH 50
#define FUNCTION_SUCCESS 0
#define FUNCTION_FAILED -1

enum Operations { GET, GETNEXT, SET, WALK, TRAP };
char * operationsArray[5] = { "GET", "GETNEXT", "SET", "WALK", "TRAP" };

/****************** SECTION 2 ******************/
INT programMode, operation;
LPSTR SNMPAgentName, SNMPCommunity, OIDstring;
RFC1157VarBindList variableBindings;
LPSNMP_MGR_SESSION SNMPsession;
AsnAny retrievedInstanceValue;
INT timeout = TIMEOUT;
INT retries = RETRIES;
BYTE requestType;
AsnInteger errorStatus, errorIndex;
#endif
/****************** SECTION 3 ******************/

#ifdef  __cplusplus
extern "C" int startupRoutine(int argc, char *argv []);
extern "C" int dispatchOperation(int programMode, char * argumentVector[]);
#else
	int startupRoutine(int argc, char *argv []);
	int dispatchOperation(int programMode, char * argumentVector[]);
	int prepareForOp(enum Operations reqOperation, LPSTR agentName,
			LPSTR community, char *objectIdentifier, char *objectValue);
	int doSnmpOperation(enum Operations reqOperation, LPSTR agentName,
			LPSTR community, char *objectIdentifier, char *objectValue);
	int allocateResources(LPSTR agentName, 
			LPSTR community, char *objectIdentifier);
	int deallocateResources();
	int prepareDataForOperation(enum Operations reqOperation, 
					unsigned char *newObjectValue);
	int prepareSetOperation(unsigned char *newObjectValue);
	int prepareGetOperation();
	int prepareGetNextOperation();
	int createSNMPSession();
	int executeMibWalk();
	int executeRequest();
	int displayMIBInstanceValue(enum Operations reqOperation);
	void waitForTraps();
#endif